
/*
** Copyright (c) 2006 Herbert Poetzl
**
** V0.01	test for new ioctl
**
*/

#define VERSION "V0.01"

#include <stdio.h>
#include <stdlib.h>
#include <errno.h>
#include <unistd.h>
#include <sys/ioctl.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>



#define BLKHOLDER _IO(0x12,115)


#define OPEN_FLAGS (O_RDONLY|O_NONBLOCK)
 
static	char	err_flag = 0;

static	char *	cmd_name = NULL;

#define OPTIONS "+h"

int	main(int argc, char *argv[])
{
        extern int optind;
        extern char *optarg;
        char c, errflg = 0;
	int r;

        cmd_name = argv[0];
        while ((c = getopt(argc, argv, OPTIONS)) != EOF) {
            switch (c) {
            case 'h':
                fprintf(stderr,
                    "This is %s " VERSION "\n"
                    "options are:\n"
                    "-h        print this help message\n"
                    "--        end of options\n"
                    ,cmd_name);
                exit(0);
                break;
            case '?':
            default:
                errflg++;
                break;
            }
        }
        if (errflg) {
            fprintf(stderr, 
                "Usage: %s -[" OPTIONS "] ...\n"
                "%s -h for help.\n",
                cmd_name, cmd_name);
            exit(2);
        }

        for (; optind < argc; optind++) {
	    const char *name = argv[optind];
	    int fd;

	    fd = open(name, OPEN_FLAGS);
	    if (fd<0)
	        perror("open:");

	    r = ioctl(fd, BLKHOLDER);
	        perror("ioctl:");
	    close (fd);
	}

	exit((err_flag)?1:0);
}

